# CSC 111, Practice Final, Part 3 Code
# Author: Sara Mathieson
# Create a diamond shape that moves in a diamond pattern.


from graphics import *


class Diamond:

    def __init__(self, x, y, dx, dy):
        """Create a diamond and set up the position and speed."""
        p1,p2,p3,p4 = Point(x-20,y), Point(x,y-20), Point(x+20,y), Point(x,y+20)
        
        self.shape = Polygon(p1, p2, p3, p4)
        self.shape.setFill("silver")
        
        self.x, self.y = x, y
        self.dx, self.dy = dx, dy


    def draw(self, window):
        """Draw the diamond on the window."""
        self.shape.draw(window)


    def move(self, width, height):
        """Move the shape a little bit in the dx,dy direction."""
        print(self.x, self.y)

        # if the shape is at a left/right boundary, flip x-direction
        if self.x < 20 or self.x > width-20:
            self.dx = -self.dx

        # if the shape is at a top/bottom boundar, flip y-direction
        if self.y < 20 or self.y > height-20:
            self.dy = -self.dy

        # move the shape in the desired direction
        self.shape.move(self.dx,self.dy)

        # update the shape's position (very important!)
        self.x += self.dx
        self.y += self.dy


def main():
    """Create diamond and move it indefinitely."""

    width = 600
    height = 600
    win = GraphWin("Diamond", width, height)

    shape = Diamond(width/2, 20, 5, 5) # call constructor
    shape.draw(win)
    while True:
        shape.move(width, height) # move shape


main()
